/* asm.S */

#define BAUDRATE_H ( ( ( F_CPU / 16 ) >> 16 ) & 0xff )
#define BAUDRATE_M ( ( ( F_CPU / 16 ) >> 8 ) & 0xff )
#define BAUDRATE_L ( ( F_CPU / 16 ) & 0xff )

/*
 *	void memCopy(*d,*s,len);		// SRAM to SRAM copy
 *
 *	: len1`127܂.	(tiny2313SRAM128oCgȂ̂.)
 *		  len <= 0 ̂Ƃ͉Ȃ.
 */

/*************************************************************/
	.text
	.global	memCopy
	.type	memCopy, @function

memCopy:
	cp r1,r20	/* __zero_reg__,r20 */
	brge .L4

	movw r26,r24
	movw r30,r22

.L3:
	ld		r24,Z+
	st		X+,r24
	subi	r20,1
	brne	.L3
.L4:
	ret


#include <avr/io.h>		//@@kuga


/*************************************************************/
/*
 *	void  baud_calc(int baud_l,uchar baud_h);
 *
 *	{[[g bbr̒l߂.
 *	UBRRL,UBRRHɐݒ肷.
 *
 */
	.global	baud_calc
	.type	baud_calc, @function
//	-----------------------------------------------------------------------
//
//	ubrr = ( r / baud ) - 1 ߂.
//	:
//	   baud:  r22:r25:r24  17bit. {[[ĝ.(r22͉1bit̂ݎgp)
//	ϐ:
//	   r:     r22:r21:r20  24bit  萔F USARTɗ^NbN/2.
//	   i:	      r19:r18  16bit. {[[g̋t. UBRRɃZbgl.
//	:
//	   (-1) => i  UBRR ɏŖ߂(void)
//	-----------------------------------------------------------------------

baud_calc:
// p[^obt@[[璼ڈ悤ɕύXiR[hGA팸j
	ldi	r30,lo8(modeBuffer)
	ldi	r31,hi8(modeBuffer)
	ldd	r24,Z+0
	ldd	r25,Z+1
	ldd	r22,Z+2

	// 24bit baud >>1 .
	lsr r22
	ror r25
	ror r24

	// r = 12000000/8/2; 	USARTɗ^NbN/2.(U2X=1̂Ƃ)
	// 0x0f4240 = 16000000/8/2 = 1000000
	ldi r20,BAUDRATE_L
	ldi r21,BAUDRATE_M
	ldi r22,BAUDRATE_H

	// i = (-2);		ȉ̃[vłȉl (-1).
	ldi r18,lo8(-2)	//  AAʂƂ-1̂ŁA(-2)^.
	ldi r19,hi8(-2)

	// i = (r/b) ̊ZZ[vŎs.
.L8:
	// i++;
	subi r18,lo8(-(1))
	sbci r19,hi8(-(1))

	// r = r - b;	   24biẗZs.
	sub r20,r24
	sbc r21,r25
	sbc r22,r1		// baud16bitȂ̂ bit23:16  [Œ.
	brcc .L8		// ܂.
.L9:
	out _SFR_IO_ADDR(UBRRH),r19
	out _SFR_IO_ADDR(UBRRL),r18

	ret

#if	0	/* ͎gȂ */

#define	int24 long

int baud_calc(int baud)
{
	int24 r = 12000000/8/2;
	baud /= 2;
	baud &= 0xffff;

	int i=-2;	// l=-1,Ɍʂ -1 .
	do {
		i++;
		r -= baud;
	}while(r>=0);
	return i;
}
#endif

;*****
;REGISTER uint8_t RxRp ASM("r8");	//Mf[^ǂݍ
;REGISTER uint8_t RxWp ASM("r9");	//Mf[^
;REGISTER uint8_t TxRp ASM("r10");	//Mf[^ǂݍ
;REGISTER uint8_t TxWp ASM("r11");	//Mf[^
;*****

	.global	USART_getc
	.type	USART_getc, @function

//
//  N`J?xWp,?x,Rp荞݋֎~ɂXV邽߂
//	AZu֐Ƃ
//

USART_getc:
	mov	r25,r8
	ldi	r30,lo8(USART_rxbuf)
	ldi	r31,hi8(USART_rxbuf)
	add	r30,r8
;	adc	r31,r1		//ram128Ȃ̂ŌJオȂ
	ld	r24,Z
	inc	r25
	andi	r25,(RXBUF_SIZE-1)
	mov	r8,r25
	eor	r25,r25		//ucharԂ̂ɕKvH
	ret

	.global	USART_putc
	.type	USART_putc, @function

#if 0	//	M݂߂̂ł߂
//
//	M̋󂫂Ȃꍇ͂A悤ɕύXׂHH
//	MBUFF8oCgƂȂAUSBpPbgTCYƓȂ̂
//	IȐ䂪łȂArsbuf 16oCgɕύXƃX^bNs
//
USART_putc:
	mov	r25,r11
	inc	r25
	andi	r25,0x0F	//(TXBUF_SIZE-1)
.L5:
	cp	r10,r25	//Mobt@[̋󂫊mF
	breq	.L5		//󂫖󂫂ł܂ő҂
	ldi	r30,lo8(rsbuf)
	ldi	r31,hi8(rsbuf)
	add	r30,r11		//TxWp
;	adc	r31,r1		//ram128Ȃ̂ŌJオȂ
	st	Z,r24
	mov	r11,r25
	sbi	_SFR_IO_ADDR(UCSRB),UDRIE
	ret

//
//
//USB݂̊jQȂ悤,݋֎~Ԃ͋ɗ͒Z
//Gggł͂Ȃ̂Ŏg݂̊֎~Ŋ荞݋
//
#endif

	.text
    .global USART_RX_vect
    .type   USART_RX_vect, @function


USART_RX_vect:
	cbi	_SFR_IO_ADDR(UCSRB),RXCIE
	out	_SFR_IO_ADDR(GPIOR0),r18
	sei			//݂ۗĂsei̖̎߂͊܂ꂸs
	in	r18,_SFR_IO_ADDR(UDR)	//f[^܂ł͊݋֎~Ŏs
	in	r2,_SFR_IO_ADDR(SREG)	//r2=SREGZ[uWX^
;	push	r30
;	push	r31
	out	_SFR_IO_ADDR(GPIOR1),r30	//X^bN[ȂȂ悤
	out	_SFR_IO_ADDR(GPIOR2),r31	//IOɃWX^ۑ
	ldi	r30,lo8(USART_rxbuf)
	ldi	r31,hi8(USART_rxbuf)
	add	r30,r9		//RxWp
;	adc	r31,r1		//ram128Ȃ̂ŌJオȂ
	st	Z,r18
	mov	r18,r9
	inc	r18
	andi	r18,(RXBUF_SIZE-1)
	cpse	r8,r18		//obt@[FULLȂ
	 mov	r9,r18		//|C^̍XVȂ(Mf[^͏㏑Ŕj)

	in	r31,_SFR_IO_ADDR(GPIOR2)	;	pop	r31
	in	r30,_SFR_IO_ADDR(GPIOR1)	;	pop	r30

	in	r18,_SFR_IO_ADDR(GPIOR0)
	out	_SFR_IO_ADDR(SREG),r2
	cli	//̎_ŎM݂ۗƂ܂
	sbi	_SFR_IO_ADDR(UCSRB),RXCIE	//ēxM݂
	reti
;
#if 0		//Mݎgp~i\PȂj

	.text

	.global USART_UDRE_vect
	.type	USART_UDRE_vect, @function


USART_UDRE_vect:
	cbi	_SFR_IO_ADDR(UCSRB),UDRIE
	sei
	in	r3,_SFR_IO_ADDR(SREG)
	cp	r10,r11		//Mf[^邩mF
	breq	.L6		//Mf[^Ȃ
;	push	r30
;	push	r31
	out	_SFR_IO_ADDR(OCR0A),r30	//X^bN[ȂȂ悤
	out	_SFR_IO_ADDR(OCR0B),r31	//IOɃWX^ۑ(^C}[0rWX^]p)
	ldi	r30,lo8(rsbuf)
	ldi	r31,hi8(rsbuf)
	add	r30,r10		//TxRp
;	adc	r31,r1		//ram128Ȃ̂ŌJオȂ
	ld	r31,Z
	out	_SFR_IO_ADDR(UDR),r31
	mov	r31,r10
	inc	r31
	andi	r31,0x0F	//(TXBUF_SIZE-1)
	mov	r10,r31
	in	r31,_SFR_IO_ADDR(OCR0B)	;	pop	r31
	in	r30,_SFR_IO_ADDR(OCR0A)	;	pop	r30
	out	_SFR_IO_ADDR(SREG),r3
	cli	//܂Ŏs̊ԂɊ܂Ă̊ԂɑM͊Ă邩mȂ
	sbi	_SFR_IO_ADDR(UCSRB),UDRIE
	reti
.L6:		//M݋֎~̂܂܏I
	out	_SFR_IO_ADDR(SREG),r3
	reti

#endif




/*************************************************************/
